#!/usr/bin/perl -w
use strict;

use IO::Socket::INET;

##---------------------------
## Creating socket to server
my $sock = new IO::Socket::INET
(
    PeerAddr => 'localhost',
    PeerPort => 9100,
    Proto => 'tcp',
);
die "Socket could not be created. $!\n" unless $sock;
$sock->autoflush(1);

##---------------------------------------
## recieving synchronization characters
$_ = <$sock>; chomp;
my $end_tag = $_;
$_ = <$sock>; chomp;
my $new_line = $_;
$_ = <$sock>; chomp;
my $no_display = $_;
WORK: while( 1 < 2 ) {
    my $no_echo = 0;

    ##------------------------------------------------
    ## run this loop while server has something to say
    while (<$sock>) {
	# print "'$_'\net = " , $end_tag, "\n\n";
	if($_ eq "Bye!$end_tag\n") {last WORK;}
	chop;
	if(m{$no_display}) {
	    $no_echo = 1;
	    s{$no_display}{};
	}
	if(m{$end_tag}x) {
	    #print "<last command>";
	    s{ $end_tag .* | $end_tag }{}sx;
	    s{$new_line}{\n};
	    #s{\n_}{\__};
	    print $_;
	    last;
	}
	else {
	    s{$new_line}{\n};
	    print $_;
	}
    }
    #print $_;
    if($no_echo == 1) {system 'stty -echo'};
    $_ =  <STDIN>;
    if($no_echo == 1) {
	system 'stty echo';
	$no_echo = 0;
    }
    chomp;
    ##------------------------------------------
    ## send to server what was read from console
    print $sock "$_\n";
}
close ( $sock );
